diff --git a/tools/testing/roadtest/.gitignore b/tools/testing/roadtest/.gitignore
new file mode 100644
index 000000000000..0cbd00343694
--- /dev/null
+++ b/tools/testing/roadtest/.gitignore
@@ -0,0 +1,2 @@
+__pycache__
+.py[cod]
diff --git a/tools/testing/roadtest/Dockerfile b/tools/testing/roadtest/Dockerfile
new file mode 100644
index 000000000000..f2982179c327
--- /dev/null
+++ b/tools/testing/roadtest/Dockerfile
@@ -0,0 +1,25 @@
+FROM debian:bullseye
+
+# Kernel build
+RUN apt-get update && apt-get -y install \
+    bc \
+    build-essential \
+    flex \
+    bison \
+    rsync \
+    kmod
+
+# Running roadtests
+RUN apt-get update && apt-get -y install \
+     python3.9 \
+     libpython3.9-dev \
+     python3 \
+     device-tree-compiler
+
+# Development and debugging
+RUN apt-get update && apt-get -y install \
+     uml-utilities \
+     telnetd \
+     python3-pip
+COPY requirements.txt /tmp/
+RUN pip install --requirement /tmp/requirements.txt
diff --git a/tools/testing/roadtest/Makefile b/tools/testing/roadtest/Makefile
new file mode 100644
index 000000000000..525b26581142
--- /dev/null
+++ b/tools/testing/roadtest/Makefile
@@ -0,0 +1,84 @@
+# SPDX-License-Identifier: GPL-2.0-only
+# Copyright Axis Communications AB
+
+.PHONY: all build-kernel test clean check fmt docker-run
+
+all:
+
+KSOURCE := ${PWD}
+ROADTEST_DIR = ${CURDIR}
+ROADTEST_BUILD_DIR := ${KSOURCE}/.roadtest
+KHEADERS := ${ROADTEST_BUILD_DIR}/usr
+KMODULES := ${ROADTEST_BUILD_DIR}/modules
+
+ifeq (${KSOURCE},${ROADTEST_DIR})
+# Make make from the standard roadtest directory work without having to set
+# additional variables.
+KSOURCE=$(ROADTEST_DIR:/tools/testing/roadtest=)
+endif
+
+CFLAGS += -g -D_GNU_SOURCE=1 -Wall -Werror -std=gnu99 \
+			-I${KSOURCE}/tools/include/ \
+			-I${KHEADERS}/include/ \
+			-I${ROADTEST_DIR}/src/libvhost-user/ \
+			$(shell python3-config --embed --includes) -O2
+
+${ROADTEST_BUILD_DIR}/roadtest-backend: ${ROADTEST_BUILD_DIR}/backend.o ${ROADTEST_BUILD_DIR}/libvhost-user.o
+	$(CC) -o $@ $^ $(shell python3-config --embed --libs)
+	# For the benefit of clangd
+	echo ${CFLAGS} | tr " " "\n" > ${ROADTEST_DIR}/src/compile_flags.txt
+
+${ROADTEST_BUILD_DIR}/backend.o: src/backend.c
+	$(CC) -c -o $@ $(CFLAGS) $<
+
+${ROADTEST_BUILD_DIR}/libvhost-user.o: src/libvhost-user/libvhost-user.c
+	$(CC) -c -o $@ $(CFLAGS) $<
+
+clean:
+	rm -rf ${ROADTEST_BUILD_DIR} .docker_built
+
+ifeq ($(DOCKER),1)
+.docker_built: Dockerfile requirements.txt
+	docker build --network=host -t roadtest ${ROADTEST_DIR}
+	touch $@
+
+# --network=host allows UML's con=port:... to work seamlessly
+docker-run: .docker_built
+	mkdir -p ${ROADTEST_BUILD_DIR}/umltmp
+	docker run --network=host ${DOCKEROPTS} --user $(shell id -u ${USER}):$(shell id -g ${USER}) --interactive --tty --rm -v ${KSOURCE}:${KSOURCE} -w ${KSOURCE} --env TMPDIR=${ROADTEST_BUILD_DIR}/umltmp roadtest sh -c '${MAKE} -C ${ROADTEST_DIR} -${MAKEFLAGS} ${MAKECMDGOALS} DOCKER=0'
+
+all test build-kernel check fmt: docker-run
+	@:
+else
+all: test
+
+ifneq ($(KBUILD),0)
+# Calling make on the kernel is slow even if there is nothing to be rebuilt.
+# Allow the user to avoid it with KBUILD=0
+${ROADTEST_BUILD_DIR}/backend.o: build-kernel
+${ROADTEST_BUILD_DIR}/libvhost-user.o: build-kernel
+test: build-kernel
+endif
+
+build-kernel:
+	mkdir -p ${ROADTEST_BUILD_DIR}
+	find ${ROADTEST_DIR}/roadtest/tests/ -type f -name config | xargs cat > ${ROADTEST_BUILD_DIR}/.config
+	${MAKE} -C ${KSOURCE} ARCH=um O=${ROADTEST_BUILD_DIR} olddefconfig
+	${MAKE} -C ${KSOURCE} ARCH=um O=${ROADTEST_BUILD_DIR}
+	${MAKE} -C ${KSOURCE} ARCH=um O=${ROADTEST_BUILD_DIR} INSTALL_HDR_PATH=${KHEADERS} headers_install
+	${MAKE} -C ${KSOURCE} ARCH=um O=${ROADTEST_BUILD_DIR} INSTALL_MOD_PATH=${KMODULES} modules_install
+
+test: ${ROADTEST_BUILD_DIR}/roadtest-backend
+	python3 -m roadtest.cmd.main --ksrc-dir ${KSOURCE} --build-dir ${ROADTEST_BUILD_DIR} --work-dir ${ROADTEST_BUILD_DIR}/roadtest-work/ ${OPTS}
+
+check:
+	mypy --no-error-summary roadtest
+	pyflakes roadtest
+	black --check roadtest
+	isort --profile black --check roadtest
+
+fmt:
+	black roadtest
+	isort --profile black roadtest
+
+endif
diff --git a/tools/testing/roadtest/pyproject.toml b/tools/testing/roadtest/pyproject.toml
new file mode 100644
index 000000000000..6b8b05eb3cad
--- /dev/null
+++ b/tools/testing/roadtest/pyproject.toml
@@ -0,0 +1,10 @@
+[tool.isort]
+profile = "black"
+
+[tool.mypy]
+disallow_untyped_defs = true
+check_untyped_defs = true
+no_implicit_optional = true
+warn_return_any = true
+warn_unused_ignores = true
+show_error_codes = true
diff --git a/tools/testing/roadtest/requirements.txt b/tools/testing/roadtest/requirements.txt
new file mode 100644
index 000000000000..e1ac403d826e
--- /dev/null
+++ b/tools/testing/roadtest/requirements.txt
@@ -0,0 +1,4 @@
+black==22.1.0
+isort==5.10.1
+mypy==0.931
+pyflakes==2.4.0
diff --git a/tools/testing/roadtest/src/.gitignore b/tools/testing/roadtest/src/.gitignore
new file mode 100644
index 000000000000..895dab3fe4be
--- /dev/null
+++ b/tools/testing/roadtest/src/.gitignore
@@ -0,0 +1 @@
+compile_flags.txt